RuneFrame:UnregisterAllEvents()
RuneFrame:Hide()
RuneFrame:SetScript("OnUpdate", nil)

if(select(2,UnitClass("player")) ~= "DEATHKNIGHT" or FreeUI.class.deathknight == false) then return end

local point = "CENTER"
local x = 0
local y = 0

dkRunes = CreateFrame("Frame","dkRunes",UIParent)

dkRunes:SetScript("OnEvent", function(self, event, ...)
	self[event](self, event, ...)
end)

dkRunes:RegisterEvent("ADDON_LOADED")

local color = {
    [1] = { 187/255, 43/255, 50/255 }, -- blood
    [2] = { 108/255, 187/255, 43/255 }, -- unholy
    [3] = { 55/255, 100/255, 161/255 }, -- frost
    [4] = { 142/255, 52/255, 155/255 }, -- death
}

local runemap = { 1,2, 5,6, 3,4 }

local runes = {}

function dkRunes.ADDON_LOADED(self,event,arg1)
    
	self:RegisterEvent("RUNE_TYPE_UPDATE")
	self:RegisterEvent("RUNE_POWER_UPDATE")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
    
	local prev
	for index, id in ipairs(runemap) do
		local bar = self:CreateBar(id)
		if prev then
			bar:SetPoint("BOTTOMLEFT", prev, "BOTTOMRIGHT", 3,0)
		else
			bar:SetPoint("BOTTOMLEFT", UIParent, "CENTER", -37.5, -110)
		end

		runes[index] = bar
		prev = bar
	end
end

function dkRunes.PLAYER_ENTERING_WORLD(self, event)
	for i,rune in pairs(runes) do
		self:RUNE_POWER_UPDATE(nil, i, true)
	end

	self:RUNE_TYPE_UPDATE()
end

function dkRunes.RUNE_TYPE_UPDATE(self, event)
	for id, rune in ipairs(runes) do
		local slot = rune.id
		if GetRuneType(slot) ~= rune.type then
			local newtype = GetRuneType(slot)
			rune.color:SetVertexColor(unpack(color[newtype]))
			rune.type = newtype
		end
	end
end

function dkRunes.RUNE_POWER_UPDATE(self, event, slot, usable)
	local rune = runes[runemap[slot]]
	if rune then
		start, duration, runeReady = GetRuneCooldown(slot)
		if usable then rune:Shine() end
		rune.startTime = start or 0
		rune.duration = duration or 10
		rune.ready = runeReady
	end
end

function dkRunes.CreateBar(self, id)
	local f = CreateFrame("Frame",nil,dkRunes)
	local height = 60
	local width = 10
	f:SetWidth(width)
	f:SetHeight(height)
	f.maxHeight = height

	f.id = id
	f.ready = false
    
	f:SetBackdrop({
		bgFile = FreeUI.backdrop,
		edgeFile = FreeUI.backdrop,
		edgeSize = 1,
		insets = { left = -1, right = -1, top = -1, bottom = -1 },
	})
	f:SetBackdropColor(0, 0, 0)
	f:SetBackdropBorderColor(0, 0, 0)

	local color = f:CreateTexture(nil, "ARTWORK")
	color:SetTexture(FreeUI.backdrop)
	color:SetAllPoints(f)
	f.color = color

	local shine = f:CreateTexture(nil, "OVERLAY")
	shine:SetTexture(FreeUI.backdrop)
	shine:SetAllPoints(f)
	shine:SetAlpha(0)
	f.shine = shine
	f.Shine = function(self)
		local frame = self.shine
		UIFrameFade(frame,{
			mode = "IN",
			timeToFade = 0.2,
			finishedFunc = function(frame) self:GetParent().shining = false; UIFrameFadeOut(frame, 0.8); end,
			finishedArg1 = frame
		})

		self.shining = true 
	end

	f.startTime = 0
	f.duration = 10
	f.OnUpdateCounter = 0
	f:SetScript("OnUpdate",function(self, time)
		self.OnUpdateCounter = self.OnUpdateCounter + time
		if self.OnUpdateCounter < 0.1 then return end
		self.OnUpdateCounter = 0

		local value = (GetTime() - self.startTime) / self.duration
		if value > 1 then value = 1 end
		self:SetHeight(self.maxHeight * value)
	end)

	local ooc = CreateFrame("Frame")
	ooc:RegisterEvent("PLAYER_REGEN_ENABLED")
	ooc:RegisterEvent("PLAYER_LOGIN")
	local Hide = function()
		UIFrameFade(f,{
			mode = "OUT",
			timeToFade = .8,
			finishedArg1 = f
		})
		
		-- self.fading = true
	end

	ooc:SetScript("OnEvent", Hide)

	local combat = CreateFrame("Frame")
	combat:RegisterEvent("PLAYER_REGEN_DISABLED")
	local Show = function()
		UIFrameFade(f,{
			mode = "IN",
			timeToFade = .8,
			finishedArg1 = f
		})
		
		-- self.fading = true
	end

	combat:SetScript("OnEvent", Show)

	return f
end