if(select(2,UnitClass("player")) ~= "WARRIOR" or FreeUI.class.warrior_shouts == false) then return end

if not shoutdb then shoutdb = {} end
if shoutdb.mode == nil then shoutdb.mode = 1 end

SlashCmdList.BATTLE = function() 
	shoutdb.mode = 1 
	print("Battle shout mode.")
end
SLASH_BATTLE1 = "/battle"
SLASH_BATTLE2 = "/bshout"

SlashCmdList.COMMANDING = function()
	shoutdb.mode = 2
	print("Commanding shout mode.")
end
SLASH_COMMANDING1 = "/commanding"
SLASH_COMMANDING2 = "/cshout"

local bshout = {
	[1] = GetSpellInfo(47436), -- battle shout
	[2] = GetSpellInfo(48932), -- blessing of might
	[3] = GetSpellInfo(48934), -- greater blessing of might
}

local cshout = {
	[1] = GetSpellInfo(469), -- commanding shout
}

local _, _, bshoutIcon = GetSpellInfo(47436)
local _, _, cshoutIcon = GetSpellInfo(469)

local frame = CreateFrame("Frame", nil, UIParent)
frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", 840, 362)
frame:SetHeight(57)
frame:SetWidth(57)

frame.icon = frame:CreateTexture(nil, "BACKGROUND")
frame.icon:SetAllPoints(frame)
frame.icon:SetTexCoord(.08, .92, .08, .92)

local ShouldShout = function()
	if (not UnitAffectingCombat("player")) then return false end
	if (UnitHasVehicleUI("player")) then return false end

	if(shoutdb.mode == 2) then
		local name = UnitBuff("player", cshout[1])
		if(name or not GetSpellInfo(cshout[1])) then
			return false
		end
	else
		for i=1, #bshout do
			local name = UnitBuff("player", bshout[i])
			if(name or not GetSpellInfo(bshout[1])) then
				return false
			end
		end
	end
	return true
end

frame:RegisterEvent("UNIT_AURA")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("UNIT_ENTERING_VEHICLE")
frame:RegisterEvent("UNIT_EXITED_VEHICLE")
frame:RegisterEvent("PLAYER_DEAD")
frame:SetScript("OnEvent", function(self, event, ...)
	if (event == "UNIT_AURA" or event == "UNIT_ENTERING_VEHICLE" or event == "UNIT_EXITED_VEHICLE") and ... ~= "player" then return end
	if(shoutdb.mode == 2) then
		frame.icon:SetTexture(cshoutIcon)
		if ShouldShout() then
			self:SetAlpha(1)
		else
			self:SetAlpha(0)
		end
	else
		frame.icon:SetTexture(bshoutIcon)
		if ShouldShout() then
			self:SetAlpha(1)
		else
			self:SetAlpha(0)
		end
	end
end)

local bg = CreateFrame ("Frame", nil, frame)
bg:SetBackdrop( { 
	bgFile = FreeUI.backdrop, 
})

bg:SetBackdropColor(0, 0, 0)
bg:SetPoint("TOPLEFT", frame, -1, 1)
bg:SetPoint("BOTTOMRIGHT", frame, 1, -1)
bg:SetFrameStrata("LOW")
bg:SetFrameLevel(0)