local n = UnitName("player")
local lvl = UnitLevel("player")

--[[ General config ]]

FreeUI["config"] = {
	["aero"] = true,			-- smooth window animations
	["audio_alert"] = true, 		-- audio alert for low health/mana
	["autoroll"] = true, 			-- automatically DE or greed on BoE greens (DE priority)
	["exp_showtext"] = false, 		-- show text on exp/rep bar	
	["healmode"] = false, 			-- enable healer unitframes
	["healmode_oldstyle"] = false, 		-- old unit frame style for heal mode
	["hotkey"] = false, 			-- show hot keys on buttons
	["minimap_bottomright"] = true, 	-- what do you think?
	["reminder"] = true, 			-- reminder for class buffs
	["wg_timer"] = true, 			-- enable a WG timer on the minimap
	["wg_mouseover"] = true,		-- only on mouseover?
}

-- [[ Character specific ]]

if n == "Amathal" then
	FreeUI.config.healmode = true
end

--[[ Level specific ]]

if lvl ~= 80 then
	FreeUI.config.autoroll = false
end

-- [[ Class ]]

-- Class-specific modules
FreeUI["class"] = {
	["deathknight"] = true, 	-- runes
	["paladin"] = true,		-- at of war
	["shaman"] = true, 		-- totem bars
	["warrior_shouts"] = true, 	-- shout reminder
	["warrior_shieldslam"] = true,	-- shield slam alert
}

-- Selfbuff reminder
FreeUI["selfbuffs"] = { -- 
	PRIEST = {
		588, -- inner fire
	},
	HUNTER = {
		13163, -- monkey
		13165, -- hawk
		5118, -- cheetah
		34074, -- viper
		13161, -- beast
		13159, -- pack
		20043, -- wild
		61846, -- dragonhawk
	},
	MAGE = {
		168, -- frost armor
		6117, -- mage armor
		7302, -- ice armor
		30482, -- molten armor
	},
	WARLOCK = {
		28176, -- fel armor
		706, -- demon armor
		687, -- demon skin
	},
	PALADIN = {
		21084, -- seal of righteousness
		20375, -- seal of command
		20164, -- seal of justice
		20165, -- seal of light
		20166, -- seal of wisdom
		53736, -- seal of corruption
		31801, -- seal of vengeance
	},
	SHAMAN = {
		52127, -- water shield
		324, -- lightning shield
		974, -- earth shield
	},
	DEATHKNIGHT = {
		57330, -- horn of Winter
		8075, -- Shaman Strength of Earth Totem
	},
}

-- sFilter buff tracker
FreeUI["sfilter"] = {
	["PALADIN"] = {
	-- Divine Plea
	{spellId = 54428, size = 26, unitId = "player", isMine = 1, filter = "HELPFUL", setPoint = {"CENTER", UIParent, "BOTTOMLEFT", 942, 348}},
	-- Divine Shield, Hand of Protection, Divine Protection, Avenging Wrath
	{spellId = 642, spellId2 = 10278, spellId3 = 498, spellId4 = 31884, size = 57, unitId = "player", isMine = "all", filter = "HELPFUL", setPoint = {"CENTER", UIParent, "BOTTOMLEFT", 840, 362}},
	-- Sacred Shield
	{spellId = 53601, size = 26, unitId = "player", isMine = "all", filter = "HELPFUL", setPoint = {"CENTER", UIParent, "BOTTOMLEFT", 738, 348}},
	}
}

--[[ oUF ]]

FreeUI["debuffFilter"] = {
	["Sunder Armor"] = true,
	["Expose Armor"] = true,
	["Thunder Clap"] = true,
	["Infected Wounds"] = true,
	["Frost Fever"] = true,
	["Demoralizing Shout"] = true,
	["Demoralizing Roar"] = true,
	["Vindication"] = true,
	["Polymorph"] = true,
	["Blind"] = true,
	["Sap"] = true,
	["Kidney Shot"] = true,
	["Cheap Shot"] = true,
	["Bash"] = true,
	["Hammer of Justice"] = true,
	["Repentance"] = true,
	["Strangulate"] = true,
	["Shackle Undead"] = true,
	["Entangling Roots"] = true,
	["Cyclone"] = true,
	["Hibernate"] = true,
	["Banish"] = true,
	["Wyvern Sting"] = true,
	["Hex"] = true,
	["Taunt"] = true,
	["Challenging Shout"] = true,
	["Mocking Blow"] = true,
	["Righteous Defense"] = true,
	["Hand of Reckoning"] = true,
	["Death Grip"] = true, 
	["Dark Command"] = true,
	["Growl"] = true,
	["Challenging Roar"] = true,
}