  -- rActionButtonStyler by Zork, modified.

  ---------------------------------------------------
  -- CREATE ALL THE HOLDER FRAMES
  ---------------------------------------------------
    
  -- Frame to hold the ActionBar1 and the BonusActionBar
  local fbar1 = CreateFrame("Frame","rABS_Bar1Holder",UIParent)
    fbar1:SetWidth(518)
    fbar1:SetHeight(58)
  fbar1:Show()
  
  -- Frame to hold the MultibarLeft
  local fbar2 = CreateFrame("Frame","rABS_Bar2Holder",UIParent)
    fbar2:SetWidth(518)
    fbar2:SetHeight(58)
  fbar2:Show()

  -- Frame to hold the MultibarRight
  local fbar3 = CreateFrame("Frame","rABS_Bar3Holder",UIParent)
  fbar3:SetWidth(518)
  fbar3:SetHeight(58)
  fbar3:Show()  
  
  -- Frame to hold the right bars
  local fbar45 = CreateFrame("Frame","rABS_Bar45Holder",UIParent)
  fbar45:SetWidth(100)
  fbar45:SetHeight(518)
  fbar45:SetPoint("LEFT", 50, 0)

  -- Frame to hold the pet bars  
  local fpet = CreateFrame("Frame","rABS_PetBarHolder",UIParent)
  fpet:SetWidth(400)
  fpet:SetHeight(54)
  fpet:SetPoint("BOTTOMRIGHT", -30, -6)

  -- Frame to hold the shapeshift bars
  local fshift = CreateFrame("Frame","rABS_ShapeShiftHolder",UIParent)
  fshift:SetScale(0.001)
  fshift:SetAlpha(0)

  fbar1:SetPoint("BOTTOM", 21, 97)
  fbar2:SetPoint("BOTTOM", 21, 60)
  fbar3:SetPoint("BOTTOM", 21, 135)

  ---------------------------------------------------
  -- CREATE MY OWN VEHICLE EXIT BUTTON
  ---------------------------------------------------
  
  local fveb = CreateFrame("Frame","rABS_VEBHolder",UIParent)
  fveb:SetWidth(16)
  fveb:SetHeight(16)
  fveb:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 430, 419) 
  
  local veb = CreateFrame("BUTTON", "rABS_VehicleExitButton", fveb, "SecureActionButtonTemplate");
  veb:SetWidth(16)
  veb:SetHeight(16)
  veb:SetPoint("CENTER")

  FreeUI.CreateBD(veb)

  veb:RegisterForClicks("AnyUp")
  veb:SetNormalTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Up")
  veb:SetPushedTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
  veb:SetHighlightTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
  veb:SetScript("OnClick", function(self) VehicleExit() end)
  veb:RegisterEvent("UNIT_ENTERING_VEHICLE")
  veb:RegisterEvent("UNIT_ENTERED_VEHICLE")
  veb:RegisterEvent("UNIT_EXITING_VEHICLE")
  veb:RegisterEvent("UNIT_EXITED_VEHICLE")
  veb:SetScript("OnEvent", function(self,event,...)
    local arg1 = ...;
    if(((event=="UNIT_ENTERING_VEHICLE") or (event=="UNIT_ENTERED_VEHICLE")) and arg1 == "player") then
      veb:SetAlpha(1)
    elseif(((event=="UNIT_EXITING_VEHICLE") or (event=="UNIT_EXITED_VEHICLE")) and arg1 == "player") then
      veb:SetAlpha(0)
    end
  end)  
  veb:SetAlpha(0)

  ---------------------------------------------------
  -- MOVE STUFF INTO POSITION
  ---------------------------------------------------
  
  local i, f
  
  --bar1
  for i= 1, 12 do
    _G["ActionButton"..i]:SetParent(fbar1);
  end

  --bonus bar  
  BonusActionBarFrame:SetParent(fbar1)
  BonusActionBarFrame:SetWidth(0.01)
  BonusActionBarTexture0:Hide()
  BonusActionBarTexture1:Hide()
  
  --bar2
  MultiBarBottomLeft:SetParent(fbar2)
  
  --bar3
  MultiBarBottomRight:SetParent(fbar3)

  --possess bar
  PossessBarFrame:SetParent(fshift)
  PossessButton1:ClearAllPoints()
  PossessButton1:SetPoint("BOTTOMLEFT", fshift, "BOTTOMLEFT", 10, 10);
  
  --pet
  PetActionBarFrame:SetParent(fpet)
  PetActionBarFrame:SetWidth(0.01)
  PetActionButton1:ClearAllPoints()
  PetActionButton1:SetPoint("BOTTOMLEFT",fpet,"BOTTOMLEFT",10,10)

  --right bars
  MultiBarRight:SetParent(fbar45);
  MultiBarLeft:SetParent(fbar45);
  MultiBarRightButton1:ClearAllPoints()
  MultiBarLeftButton1:ClearAllPoints()

  ActionButton1:SetPoint("BOTTOMLEFT", fbar1, "BOTTOMLEFT", 10, 10)
  BonusActionButton1:SetPoint("BOTTOMLEFT", fbar1, "BOTTOMLEFT", 10, 10)
  MultiBarBottomLeftButton1:SetPoint("BOTTOMLEFT", fbar2, "BOTTOMLEFT", 10, 10)
  MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", fbar3, "BOTTOMLEFT", 10, 10)
  MultiBarRightButton1:SetPoint("TOPLEFT", fbar45, "TOPLEFT", 10, -10)
  MultiBarLeftButton1:SetPoint("TOPLEFT", MultiBarRightButton1, "TOPRIGHT", 2, 0)

  for i = 2, NUM_ACTIONBAR_BUTTONS do
	_G["ActionButton" .. i]:SetPoint("LEFT", _G["ActionButton"..i-1], "RIGHT", 2, 0)
	_G["BonusActionButton"..i]:SetPoint("LEFT", _G["BonusActionButton"..i-1], "RIGHT", 2, 0)
	_G["MultiBarBottomLeftButton"..i]:SetPoint("LEFT", _G["MultiBarBottomLeftButton"..i-1], "RIGHT", 2, 0)
	_G["MultiBarBottomRightButton"..i]:SetPoint("LEFT", _G["MultiBarBottomRightButton"..i-1], "RIGHT", 2, 0)
	_G["MultiBarRightButton"..i]:SetPoint("TOPLEFT", _G["MultiBarRightButton"..i-1], "BOTTOMLEFT", 0, -2)
	_G["MultiBarLeftButton"..i]:SetPoint("TOPLEFT", _G["MultiBarLeftButton"..i-1], "BOTTOMLEFT", 0, -2)
  end
  
  ---------------------------------------------------
  -- ACTIONBUTTONS MUST BE HIDDEN
  ---------------------------------------------------
  
  local function rABS_showhideactionbuttons(alpha)
    local f = "ActionButton"
    for i=1, 12 do
      _G[f..i]:SetAlpha(alpha)
    end
  end
  BonusActionBarFrame:HookScript("OnShow", function(self) rABS_showhideactionbuttons(0) end)
  BonusActionBarFrame:HookScript("OnHide", function(self) rABS_showhideactionbuttons(1) end)
  if BonusActionBarFrame:IsShown() then
    rABS_showhideactionbuttons(0)
  end

  ---------------------------------------------------
  -- MAKE THE DEFAULT BARS INVISIBLE
  ---------------------------------------------------
  
  local FramesToHide = {
    MainMenuBar,
    VehicleMenuBar,
  }  
  
  local function rABS_HideDefaultFrames()
    for _, f in pairs(FramesToHide) do
      f:SetScale(0.001)
      f:SetAlpha(0)
    end
  end  
  rABS_HideDefaultFrames(); 

  ---------------------------------------------------
  -- SCALING
  ---------------------------------------------------

  fbar1:SetScale(.7)
  fbar2:SetScale(.7)
  fbar3:SetScale(.7)
  fbar45:SetScale(.7)