-- rActionButtonStyler by Roth, modified.

local _G = _G

---------------------------------------
-- FUNCTIONS
---------------------------------------

--initial style func
local function rActionButtonStyler_AB_style(self)
	if not self.rabsstyle and self:GetParent():GetName() ~= "MultiCastActionBarFrame" and self:GetParent():GetName() ~= "MultiCastActionPage1" and self:GetParent():GetName() ~= "MultiCastActionPage2" and self:GetParent():GetName() ~= "MultiCastActionPage3" then
		local action = self.action
		local name = self:GetName()
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local co  = _G[name.."Count"]
		local bo  = _G[name.."Border"]
		local ho  = _G[name.."HotKey"]
		local na  = _G[name.."Name"]
		local fl  = _G[name.."Flash"]
		local nt  = _G[name.."NormalTexture"]

		nt:SetHeight(bu:GetHeight())
		nt:SetWidth(bu:GetWidth())
		nt:SetPoint("Center", 0, 0)

		bo:Hide()
		bo.Show = FreeUI.dummy

		co:SetFont(FreeUI.font, 8 / .7, "OUTLINEMONOCHROME")
		co:ClearAllPoints()
		co:SetPoint("TOP", 0, -2)

		if FreeUI.config.hotkey == true then
			ho:ClearAllPoints()
			ho:SetPoint("BOTTOM")
			ho:SetFont(FreeUI.font, 8 / .7, "OUTLINEMONOCHROME")
			ho:SetJustifyH("CENTER")
		else
			ho:Hide()
			ho.Show = FreeUI.dummy
		end

		na:Hide()

		bu:SetCheckedTexture(bu:GetHighlightTexture())
		bu:SetNormalTexture("")

		ic:SetTexCoord(.08, .92, .08, .92)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1 / .7, -1 / .7)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1 / .7, 1 / .7)

		nt.SetHeight = FreeUI.dummy
		nt.SetWidth = FreeUI.dummy
		fl.SetTexture = FreeUI.dummy
		bu.SetHighlightTexture = FreeUI.dummy
		bu.SetPushedTexture = FreeUI.dummy
		bu.SetCheckedTexture = FreeUI.dummy
		bu.SetNormalTexture = FreeUI.dummy
		co.SetPoint = FreeUI.dummy
		co.SetFont = FreeUI.dummy
		ho.ClearAllPoints = FreeUI.dummy
		ho.SetPoint = FreeUI.dummy
		ho.SetFont = FreeUI.dummy
		ho.SetJustifyH = FreeUI.dummy
		nt.SetVertexColor = FreeUI.dummy

		local bg = CreateFrame("Frame", nil, self)
		bg:SetBackdrop({ 
			edgeFile = FreeUI.backdrop, 
			edgeSize = 1 / .7, 
		})
		bg:SetBackdropBorderColor(0, 0, 0)
		bg:SetAllPoints(self)
		bg:SetFrameStrata("LOW")

		self.rabsstyle = true
	end
end

--style pet buttons
local function rActionButtonStyler_AB_stylepet()
	for i=1, NUM_PET_ACTION_SLOTS do
		local name = "PetActionButton"..i
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local fl  = _G[name.."Flash"]
		local nt  = _G[name.."NormalTexture2"]

		nt:SetHeight(bu:GetHeight())
		nt:SetWidth(bu:GetWidth())
		nt:SetPoint("Center", 0, 0)

		bu:SetCheckedTexture(FreeUI.questborder)
		bu:SetNormalTexture("")

		ic:SetTexCoord(0.08, 0.92, 0.08, 0.92)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)
	end  
end

for i=1, NUM_PET_ACTION_SLOTS do
		local name = "PetActionButton"..i
		local bu  = _G[name]
		local pbg = CreateFrame("Frame", nil, bu)
		pbg:SetBackdrop({ 
			bgFile = "", 
			edgeFile = FreeUI.backdrop, 
			edgeSize = 1 / 1, 
			insets = {left = 0, right = 0, top = 0, bottom = 0},
		})
		pbg:SetBackdropBorderColor(0, 0, 0)
		pbg:SetAllPoints(bu)
		pbg:SetFrameStrata("LOW")
end

---------------------------------------
-- CALLS // HOOKS
---------------------------------------

hooksecurefunc("ActionButton_Update",   rActionButtonStyler_AB_style)
hooksecurefunc("PetActionBar_Update",   rActionButtonStyler_AB_stylepet)