﻿local eventframe = CreateFrame"Frame"
eventframe:SetScript("OnEvent", function(self, event, arg1) self[event](self, event, arg1) end)

eventframe:RegisterEvent"MERCHANT_SHOW"
function eventframe:MERCHANT_SHOW()
	if(CanMerchantRepair()) then
		local cost = GetRepairAllCost()
		if(cost>0 and GetMoney()>cost) then
			RepairAllItems()
			print(format("Repair: %.1fg", cost * 0.0001))
		end
	end

	for bag = 0, 4 do
		for slot = 0, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if link and (select(3, GetItemInfo(link))==0) then
				UseContainerItem(bag, slot)
			end
		end
	end
end

local IsFriend = function(name)
	for i=1, GetNumFriends() do if(GetFriendInfo(i)==name) then return true end end
	if(IsInGuild()) then for i=1, GetNumGuildMembers() do if(GetGuildRosterInfo(i)==name) then return true end end end
end

eventframe:RegisterEvent"PARTY_INVITE_REQUEST"
function eventframe:PARTY_INVITE_REQUEST(event, name)
	if(IsFriend(name)) then
		AcceptGroup()
		for i = 1, 4 do
			local frame = _G["StaticPopup"..i]
			if(frame:IsVisible() and frame.which=="PARTY_INVITE") then
				frame.inviteAccepted = 1
				return StaticPopup_Hide("PARTY_INVITE")
			end
		end
	end
end