-- Used to be oGlow by Haste

local function UpdateGlow(button, id)
	local quality, texture, _
	if(id) then
		quality, _, _, _, _, _, _, texture = select(3, GetItemInfo(id))
	end

	local glow = button.glow
	if(not glow) then
		glow = CreateFrame("Frame", nil, button)
		glow:SetBackdrop({ 
			bgFile = "", 
			edgeFile = FreeUI.backdrop, 
			edgeSize = 1, 
			insets = {left = 0, right = 0, top = 0, bottom = 0},
		})
		glow:SetPoint("TOPLEFT", button, "TOPLEFT", -1, 1)
		glow:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 1, -1)
		button.glow = glow
	end

	if(texture) then
		local r, g, b = GetItemQualityColor(quality)
		if(r==1) then r, g, b = 0, 0, 0 end
		glow:SetBackdropBorderColor(r, g, b)
		glow:Show()
	else
		glow:Hide()
	end
end

hooksecurefunc("BankFrameItemButton_Update", function(self)
	UpdateGlow(self, GetInventoryItemID("player", self:GetInventorySlot()))
end)

hooksecurefunc("ContainerFrame_Update", function(self)
	local name = self:GetName()
	local id = self:GetID()

	for i=1, self.size do
		local button = _G[name.."Item"..i]
		local itemID = GetContainerItemID(id, button:GetID())
		UpdateGlow(button, itemID)
	end
end)