local c = RAID_CLASS_COLORS[select(2, UnitClass("player"))]

local f = CreateFrame("Frame")
f:SetBackdrop({
	bgFile = FreeUI.backdrop,
	edgeFile = FreeUI.glow,
	edgeSize = 3,
	insets = {left = 3, right = 3, top = 3, bottom = 3},
})
f:SetBackdropColor(1, 0, 0)
f:SetBackdropBorderColor(1, 0, 0)
f:SetAlpha(0)
f:SetWidth(8)
f:SetHeight(8)
f:SetPoint("BOTTOMRIGHT")
f:EnableMouse(true)
f:SetScript("OnMouseDown", function()
	if(IsAddOnLoaded("TinyDPS") or IsAddOnLoaded("DBM-Core")) then
		DisableAddOn("TinyDPS")
		DisableAddOn("DBM-Core")
		print("DBM and TinyDPS disabled. Type /rl for the changes to apply.")
	else
		EnableAddOn("TinyDPS")
		EnableAddOn("!dbm")
		EnableAddOn("DBM-Core")
		LoadAddOn("TinyDPS")
		LoadAddOn("!dbm")
		LoadAddOn("DBM-Core")
		print("DBM and TinyDPS loaded.")
	end
end)

f:SetScript("OnEnter", function()
	f:SetAlpha(1)
	FreeUI.CreatePulse(f)
	GameTooltip:SetOwner(f, "ANCHOR_LEFT", -2, 4)
	GameTooltip:ClearLines()
	GameTooltip:AddLine("FreeUI", c.r, c.g, c.b)
	GameTooltip:AddLine("Toggle DBM and TinyDPS", 1, 1, 1)
	GameTooltip:Show()
end)

f:SetScript("OnLeave", function()
	f:SetScript("OnUpdate", nil)
	f:SetAlpha(0)
	GameTooltip:Hide()
end)