-- Base code by Alza, most code personal.

local Scale = 0.9

Minimap:ClearAllPoints()
if FreeUI.config.minimap_bottomright == true then
	Minimap:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -50 / Scale, 50 / Scale)
else
	Minimap:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -50 / Scale, -50 / Scale)
end
Minimap:SetMaskTexture"Interface\\Buttons\\WHITE8X8"
MinimapCluster:SetScale(Scale)

FreeUI.CreateBD(Minimap)

local border = CreateFrame("Frame")
border:SetScript("OnEvent", function(self, event, ...)
	local inv = CalendarGetNumPendingInvites()
	local mail = HasNewMail()
	if inv > 0 and mail then -- New invites and mail
		Minimap:SetBackdropBorderColor(1, .5, 0)
	elseif inv > 0 and not mail then -- New invites and no mail
		Minimap:SetBackdropBorderColor(1, 30/255, 60/255)
	elseif inv==0 and mail then -- No invites and new mail
		Minimap:SetBackdropBorderColor(0, 1, 0)
	else -- None of the above
		Minimap:SetBackdropBorderColor(0, 0, 0)
	end
end)

border:RegisterEvent("CALENDAR_UPDATE_PENDING_INVITES")
border:RegisterEvent("UPDATE_PENDING_MAIL")
border:RegisterEvent("PLAYER_ENTERING_WORLD")

ZoneTextString:ClearAllPoints()
ZoneTextString:SetPoint("CENTER", Minimap)
ZoneTextString:SetWidth(Minimap:GetWidth())
ZoneTextString:SetFont(FreeUI.font, 8, "OUTLINEMONOCHROME")
SubZoneTextString:SetFont(FreeUI.font, 8, "OUTLINEMONOCHROME")
PVPInfoTextString:SetFont(FreeUI.font, 8, "OUTLINEMONOCHROME")
PVPArenaTextString:SetFont(FreeUI.font, 8, "OUTLINEMONOCHROME")

local bu = MinimapZoneTextButton
local text = MinimapZoneText
bu:ClearAllPoints()
bu:SetPoint("CENTER", Minimap)
bu:SetFrameStrata("HIGH")
bu:SetAlpha(0)
text:SetFont(FreeUI.font, 8 / Scale, "OUTLINEMONOCHROME")
text:SetShadowColor(0, 0, 0, 0)

if FreeUI.config.wg_timer == true then
	WintergraspTimer:SetParent("UIParent")
	WintergraspTimer:ClearAllPoints()
	WintergraspTimer:SetPoint("BOTTOM", Minimap)
	WintergraspTimer.text:SetFont(FreeUI.font, 8, "OUTLINEMONOCHROME")
	WintergraspTimer.text:SetShadowColor(0, 0, 0, 0)
	WintergraspTimer.text:SetJustifyH("CENTER")
	WintergraspTimer.text:ClearAllPoints()
	WintergraspTimer.text:SetAllPoints(WintergraspTimer)
	WintergraspTimer:SetWidth(100)
	WintergraspTimer.texture:SetTexture("")
	if FreeUI.config.wg_mouseover == true then
		WintergraspTimer:EnableMouse(false)
		WintergraspTimer:SetAlpha(0)

	else
		WintergraspTimer:SetScript("OnEnter", function(self)
			bu:SetAlpha(1)
			if FreeUI.config.wg_mouseover == true then WintergraspTimer:SetAlpha(1) end
		end)
		WintergraspTimer:SetScript("OnLeave", function(self)
			bu:SetAlpha(0)
			if FreeUI.config.wg_mouseover == true then WintergraspTimer:SetAlpha(0) end
		end)
	end
end

Minimap:SetScript("OnEnter", function(self)
	bu:SetAlpha(1)
	if FreeUI.config.wg_timer == true and FreeUI.config.wg_mouseover == true then WintergraspTimer:SetAlpha(1) end
end)
Minimap:SetScript("OnLeave", function(self)
	bu:SetAlpha(0)
	if FreeUI.config.wg_timer == true and FreeUI.config.wg_mouseover == true then WintergraspTimer:SetAlpha(0) end
end)

bu:EnableMouse(false)

local function CaptureBar()
	for i = 1, NUM_EXTENDED_UI_FRAMES do
		local bar = _G["WorldStateCaptureBar"..i]
		if bar and bar:IsShown() then
			bar:ClearAllPoints()
			bar:SetPoint("TOP", UIParent, "TOP", 0, -120)
		end
	end
end

hooksecurefunc("WorldStateAlwaysUpFrame_Update", CaptureBar)

do
	local frames = {
		"MiniMapInstanceDifficulty",
		"MiniMapBattlefieldBorder",
		"MiniMapVoiceChatFrame",
		"MiniMapWorldMapButton",
		"MiniMapMailBorder",
		"MinimapBorderTop",
		"MinimapNorthTag",
		"MiniMapTracking",
		"MinimapZoomOut",
		"MinimapZoomIn",
		"MinimapBorder",
	}

	for i = 1, #frames do
		_G[frames[i]]:Hide()
		_G[frames[i]].Show = FreeUI.dummy
	end
end

Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function(_, zoom)
	if(zoom>0) then
		Minimap_ZoomIn()
	else
		Minimap_ZoomOut()
	end
end)

Minimap:SetScript("OnMouseUp", function(self, button)
	if(button=="RightButton") then
		ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, "cursor", 0, 0)
	elseif(button=="MiddleButton") then
		if(not CalendarFrame) then LoadAddOn("Blizzard_Calendar") end
		Calendar_Toggle()
	else
		Minimap_OnClick(self)
	end
end)

GameTimeFrame:ClearAllPoints()
GameTimeFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", -2, -2)

local bu = _G["GameTimeFrame"]
bu:SetWidth(24)
bu:SetHeight(24)
bu:SetHitRectInsets(0, 0, 0, 0)

select(5, GameTimeFrame:GetRegions()):SetTextColor(1, 1, 1)
select(5, GameTimeFrame:GetRegions()):SetFont(FreeUI.font, 8 / Scale, "OUTLINEMONOCHROME")
select(5, GameTimeFrame:GetRegions()):ClearAllPoints()
select(5, GameTimeFrame:GetRegions()):SetPoint("CENTER", bu, "CENTER", 0, 1)

bu:SetNormalTexture("")
bu:SetPushedTexture("")
bu:SetHighlightTexture("")

MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("TOP", Minimap, "TOP", 0, 3)

MiniMapMailIcon:SetTexture(nil)

MiniMapLFGFrameBorder:SetAlpha(0)
MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrame:SetPoint("BOTTOMRIGHT", Minimap)

TicketStatusFrame:ClearAllPoints()
TicketStatusFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 50, -50)
FreeUI.CreateBD(TicketStatusFrameButton)

if FreeUI.config.minimap_bottomright == true then
	LFDSearchStatus:ClearAllPoints()
	LFDSearchStatus:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMLEFT", -5, -2)
end