-- Originally part of Tukui. Modified.

local Skin = CreateFrame("Frame", nil, UIParent)
local c = RAID_CLASS_COLORS[select(2, UnitClass("player"))]

local function reskin(f)

	local glow = CreateFrame("Frame", nil, f)
	glow:SetBackdrop({
		edgeFile = FreeUI.glow,
		edgeSize = 5,
	})
	glow:SetPoint("TOPLEFT", f, -6, 6)
	glow:SetPoint("BOTTOMRIGHT", f, 6, -6)
	glow:SetBackdropBorderColor(c.r, c.g, c.b)
	glow:SetAlpha(0)

	f:SetNormalTexture("")
	f:SetHighlightTexture("")
	f:SetPushedTexture("")
	f:SetDisabledTexture("")
	FreeUI.CreateBD(f, .25)
	f:HookScript("OnEnter", function(self) self:SetBackdropBorderColor(c.r, c.g, c.b) self:SetBackdropColor(c.r, c.g, c.b,.1) FreeUI.CreatePulse(glow) end)
 	f:HookScript("OnLeave", function(self) self:SetBackdropBorderColor(0, 0, 0) self:SetBackdropColor(0, 0, 0, .25) glow:SetScript("OnUpdate", nil) glow:SetAlpha(0) end)
end

Skin:RegisterEvent("ADDON_LOADED")
Skin:SetScript("OnEvent", function(self, event, addon)	
	if addon == "!FreeUI" then			 
		local skins = {
			"StaticPopup1",
			"StaticPopup2",
			"GameMenuFrame",
			"InterfaceOptionsFrame",
			"VideoOptionsFrame",
			"AudioOptionsFrame",
			"LFDDungeonReadyStatus",
			"ChatConfigFrame",
			"AutoCompleteBox",
		}
		 
		for i = 1, 2 do
			for j = 1, 2 do
				reskin(_G["StaticPopup"..i.."Button"..j])
			end
		end
		 
		for i = 1, getn(skins) do
			FreeUI.CreateBD(_G[skins[i]])
			FreeUI.CreateSD(_G[skins[i]])
		end

		FreeUI.CreateBD(ChatConfigCategoryFrame, .25)
		FreeUI.CreateBD(ChatConfigBackgroundFrame, .25)
		FreeUI.CreateBD(ChatConfigChatSettingsLeft, .25)
		FreeUI.CreateBD(ChatConfigChatSettingsClassColorLegend, .25)

		ChatConfigFrameDefaultButton:SetWidth(125)
		ChatConfigFrameDefaultButton:ClearAllPoints()
		ChatConfigFrameDefaultButton:SetPoint("TOP", ChatConfigCategoryFrame, "BOTTOM", 0, -4)

		ChatConfigFrameOkayButton:ClearAllPoints()
		ChatConfigFrameOkayButton:SetPoint("TOPRIGHT", ChatConfigBackgroundFrame, "BOTTOMRIGHT", 0, -4)
		 
		local menuButtons = {"Options", "SoundOptions", "UIOptions", "Keybindings", "Macros", "AddOns", "Logout", "Quit", "Continue", "MacOptions"}
		for i = 1, getn(menuButtons) do
		local button = _G["GameMenuButton"..menuButtons[i]]
			if button then
				reskin(button)
			end
		end

		local header = {"GameMenuFrame", "InterfaceOptionsFrame", "AudioOptionsFrame", "VideoOptionsFrame", "ChatConfigFrame"}
		for i = 1, getn(header) do
		local title = _G[header[i].."Header"]
			if title then
				title:SetTexture("")
				title:ClearAllPoints()
				if title == _G["GameMenuFrameHeader"] then
					title:SetPoint("TOP", GameMenuFrame, 0, 7)
				else
					title:SetPoint("TOP", header[i], 0, 0)
				end
			end
		end

		local buttons = {"VideoOptionsFrameOkay", "VideoOptionsFrameCancel", "VideoOptionsFrameDefaults", "VideoOptionsFrameApply", "AudioOptionsFrameOkay", "AudioOptionsFrameCancel", 
		                 "AudioOptionsFrameDefaults", "InterfaceOptionsFrameDefaults", "InterfaceOptionsFrameOkay", "InterfaceOptionsFrameCancel", "ChatConfigFrameOkayButton", "ChatConfigFrameDefaultButton"}
		for i = 1, getn(buttons) do
		local reskinbutton = _G[buttons[i]]
			if reskinbutton then
				reskin(reskinbutton)
			end
		end

		_G["VideoOptionsFrameCancel"]:ClearAllPoints()
		_G["VideoOptionsFrameCancel"]:SetPoint("RIGHT",_G["VideoOptionsFrameApply"],"LEFT",-4,0)		 
		_G["VideoOptionsFrameOkay"]:ClearAllPoints()
		_G["VideoOptionsFrameOkay"]:SetPoint("RIGHT",_G["VideoOptionsFrameCancel"],"LEFT",-4,0)	
		_G["AudioOptionsFrameOkay"]:ClearAllPoints()
		_G["AudioOptionsFrameOkay"]:SetPoint("RIGHT",_G["AudioOptionsFrameCancel"],"LEFT",-4,0)		 	 
		_G["InterfaceOptionsFrameOkay"]:ClearAllPoints()
		_G["InterfaceOptionsFrameOkay"]:SetPoint("RIGHT",_G["InterfaceOptionsFrameCancel"],"LEFT", -4,0)
	end

	if IsMacClient() then
		-- Skin main frame and reposition the header
		FreeUI.CreateBD(MacOptionsFrame)
		MacOptionsFrameHeader:SetTexture("")
		MacOptionsFrameHeader:ClearAllPoints()
		MacOptionsFrameHeader:SetPoint("TOP", MacOptionsFrame, 0, 0)
 
		--Skin internal frames
		FreeUI.CreateBD(MacOptionsFrameMovieRecording, .25)
		FreeUI.CreateBD(MacOptionsITunesRemote, .25)
 
		--Skin buttons
		reskin(_G["MacOptionsFrameCancel"])
		reskin(_G["MacOptionsFrameOkay"])
		reskin(_G["MacOptionsButtonKeybindings"])
		reskin(_G["MacOptionsFrameDefaults"])
		reskin(_G["MacOptionsButtonCompress"])
 
		--Reposition and resize buttons
		_G["MacOptionsButtonCompress"]:SetWidth(136)
 
		_G["MacOptionsFrameCancel"]:SetWidth(96)
		_G["MacOptionsFrameCancel"]:SetHeight(22)
		_G["MacOptionsFrameCancel"]:ClearAllPoints()
		_G["MacOptionsFrameCancel"]:SetPoint("LEFT", _G["MacOptionsButtonKeybindings"], "RIGHT", 107, 0)
 
		_G["MacOptionsFrameOkay"]:SetWidth(96)
		_G["MacOptionsFrameOkay"]:SetHeight(22)
		_G["MacOptionsFrameOkay"]:ClearAllPoints()
		_G["MacOptionsFrameOkay"]:SetPoint("LEFT", _G["MacOptionsButtonKeybindings"], "RIGHT", 5, 0)
 
		_G["MacOptionsButtonKeybindings"]:SetWidth(96)
		_G["MacOptionsButtonKeybindings"]:SetHeight(22)
		_G["MacOptionsButtonKeybindings"]:ClearAllPoints()
		_G["MacOptionsButtonKeybindings"]:SetPoint("LEFT", _G["MacOptionsFrameDefaults"], "RIGHT", 5, 0)
 
		_G["MacOptionsFrameDefaults"]:SetWidth(96)
		_G["MacOptionsFrameDefaults"]:SetHeight(22)
 
	end
end)