local function Setup()

	SetCVar("useUiScale", 1)
	SetCVar("uiScale", 768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)"))
	SetCVar("showClock", 0)
	SetCVar("hidePartyInRaid", 1)
	SetCVar("screenshotFormat", tga)
	SetCVar("cameraDistanceMax", 50)
	SetCVar("cameraDistanceMaxFactor", 3.4)
	SetCVar("nameplateShowFriends", 0)
	SetCVar("nameplateShowEnemies", 1)

	SetMultisampleFormat(1)

	FCF_ResetChatWindows()
	FCF_DockFrame(ChatFrame2)

	ChatFrame1:ClearAllPoints()
	ChatFrame1:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 50, 50)
	ChatFrame1:SetHeight(121)
	ChatFrame1:SetWidth(342)
	ChatFrame1:SetUserPlaced(true)

	FCF_SavePositionAndDimensions(ChatFrame1)
	FCF_SetLocked(ChatFrame1, 1)

	local channels = {
		"SAY",
		"EMOTE",
		"YELL",
		"GUILD",
		"OFFICER",
		"GUILD_ACHIEVEMENT",
		"ACHIEVEMENT",
		"WHISPER",
		"PARTY",
		"PARTY_LEADER",
		"RAID",
		"RAID_LEADER",
		"RAID_WARNING",
		"BATTLEGROUND",
		"BATTLEGROUND_LEADER",
		"CHANNEL1",
		"CHANNEL2",
		"CHANNEL3",
		"CHANNEL4",
		"CHANNEL5",
		"CHANNEL6",
		"CHANNEL7",
	}
	
	for i, v in ipairs(channels) do
		ToggleChatColorNamesByClassGroup(true, v)
	end

	if(DBM_SavedOptions) then table.wipe(DBM_SavedOptions) end
	if(DBT_SavedOptions) then table.wipe(DBT_SavedOptions) end

	DBM_SavedOptions = {
		["SpecialWarningFontSize"] = 50,
		["ShowWarningsInChat"] = true,
		["DontSetIcons"] = false,
		["ArrowPosX"] = 0,
		["SpecialWarningSound"] = "Sound\\Spells\\PVPFlagTaken.wav",
		["AutoRespond"] = true,
		["HealthFrameGrowUp"] = false,
		["StatusEnabled"] = true,
		["HideBossEmoteFrame"] = false,
		["ShowBigBrotherOnCombatStart"] = false,
		["BlockVersionUpdatePopup"] = true,
		["WarningColors"] = {
			{
				["b"] = 0.9411764705882353,
				["g"] = 0.8,
				["r"] = 0.4117647058823529,
			}, -- [1]
			{
				["b"] = 0,
				["g"] = 0.9490196078431372,
				["r"] = 0.9490196078431372,
			}, -- [2]
			{
				["b"] = 0,
				["g"] = 0.5019607843137255,
				["r"] = 1,
			}, -- [3]
			{
				["b"] = 0.1019607843137255,
				["g"] = 0.1019607843137255,
				["r"] = 1,
			}, -- [4]
		},
		["RangeFrameY"] = -50,
		["SpecialWarningFont"] = "Fonts\\FRIZQT__.TTF",
		["SpamBlockRaidWarning"] = true,
		["ShowFakedRaidWarnings"] = false,
		["DontSendBossAnnounces"] = false,
		["HPFrameMaxEntries"] = 5,
		["WarningIconRight"] = false,
		["RangeFramePoint"] = "CENTER",
		["SpecialWarningPoint"] = "CENTER",
		["ShowSpecialWarnings"] = true,
		["RaidWarningSound"] = "Sound\\Doodad\\BellTollNightElf.wav",
		["DontShowBossAnnounces"] = false,
		["SpecialWarningY"] = 75,
		["RangeFrameSound2"] = "none",
		["SpecialWarningX"] = 0,
		["AlwaysShowHealthFrame"] = false,
		["RaidWarningPosition"] = {
			["Y"] = -185,
			["X"] = 0,
			["Point"] = "TOP",
		},
		["HPFramePoint"] = "RIGHT",
		["Enabled"] = true,
		["RangeFrameSound1"] = "none",
		["WarningIconLeft"] = false,
		["HealthFrameWidth"] = 150,
		["RangeFrameLocked"] = false,
		["DontSendBossWhispers"] = false,
		["SpecialWarningFontColor"] = {
			0, -- [1]
			0, -- [2]
			1, -- [3]
		},
		["HPFrameY"] = -176.2242279052734,
		["HelpMessageShown"] = false,
		["RangeFrameX"] = 50,
		["ShowMinimapButton"] = false,
		["HPFrameX"] = -92.86503601074219,
		["HealthFrameLocked"] = true,
		["SpamBlockBossWhispers"] = false,
		["ArrowPosY"] = -150,
		["ArrowPoint"] = "TOP",
	}
	DBT_SavedOptions = {
		["DBM"] = {
			["EndColorG"] = 1,
			["FillUpBars"] = true,
			["HugeBarXOffset"] = 0,
			["Scale"] = 1,
			["IconLeft"] = false,
			["HugeBarYOffset"] = 0,
			["HugeWidth"] = 229,
			["BarYOffset"] = 3,
			["HugeTimerY"] = -167.9991455078125,
			["TimerX"] = -275.5000610351562,
			["ExpandUpwards"] = false,
			["TimerPoint"] = "CENTER",
			["StartColorG"] = 0,
			["HugeScale"] = 1,
			["StartColorB"] = 0,
			["EndColorR"] = 0,
			["Width"] = 229,
			["HugeTimerPoint"] = "CENTER",
			["StartColorR"] = 1,
			["FontSize"] = 10,
			["HugeBarsEnabled"] = false,
			["HugeTimerX"] = -274.9999389648438,
			["TimerY"] = -177.4993133544922,
			["BarXOffset"] = 0,
			["EndColorB"] = 0,
		},
	}

	if(tdps) then table.wipe(tdps) end

	tdps = {
		["view"] = "d",
		["newFight"] = true,
		["combat"] = false,
		["shortDamage"] = true,
		["barHeight"] = 15,
		["border"] = {
			0, -- [1]
			0, -- [2]
			0, -- [3]
			0, -- [4]
		},
		["fight"] = "o",
		["spacing"] = 1,
		["anchor"] = "TOPLEFT",
		["autoReset"] = true,
		["anchorPosition"] = {
			"TOPLEFT", -- [1]
			nil, -- [2]
			"TOPLEFT", -- [3]
			50, -- [4]
			-50, -- [5]
		},
		["maxBars"] = 10,
		["showDamage"] = true,
		["showMinimapButton"] = false,
		["showRank"] = false,
		["showPercent"] = false,
		["shortDPS"] = true,
		["swapColor"] = true,
		["backdrop"] = {
			0, -- [1]
			0, -- [2]
			0, -- [3]
			0, -- [4]
		},
		["width"] = 134,
		["classColor"] = {
			["HUNTER"] = {
				["a"] = 1,
				["b"] = 0.49,
				["g"] = 0.86,
				["r"] = 0.58,
			},
			["WARRIOR"] = {
				["a"] = 1,
				["b"] = 0.45,
				["g"] = 0.65,
				["r"] = 0.9,
			},
			["PALADIN"] = {
				["a"] = 1,
				["b"] = 0.52,
				["g"] = 0.22,
				["r"] = 1,
			},
			["MAGE"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 0.76,
				["r"] = 0,
			},
			["PRIEST"] = {
				["a"] = 1,
				["b"] = 0.9,
				["g"] = 0.87,
				["r"] = 0.8,
			},
			["WARLOCK"] = {
				["a"] = 1,
				["b"] = 0.85,
				["g"] = 0.47,
				["r"] = 0.6,
			},
			["UNKNOWN"] = {
				["a"] = 1,
				["b"] = 0.24,
				["g"] = 0.58,
				["r"] = 0.63,
			},
			["DEATHKNIGHT"] = {
				["a"] = 1,
				["b"] = 0.23,
				["g"] = 0.12,
				["r"] = 0.77,
			},
			["DRUID"] = {
				["a"] = 1,
				["b"] = 0.04,
				["g"] = 0.49,
				["r"] = 1,
			},
			["SHAMAN"] = {
				["a"] = 1,
				["b"] = 0.6,
				["g"] = 0.6,
				["r"] = 0,
			},
			["ROGUE"] = {
				["a"] = 1,
				["b"] = 0.2,
				["g"] = 0.91,
				["r"] = 1,
			},
		},
		["font"] = {
			["outline"] = "Outlinemonochrome",
			["name"] = "Interface\\AddOns\\!freeUI\\media\\Hooge0655.ttf",
			["shadowX"] = 0,
			["shadowY"] = -0,
			["size"] = 8,
		},
		["version"] = "0.84",
		["showDPS"] = true,
		["onlyBossSegments"] = false,
		["bar"] = {
			0.9, -- [1]
			0.9, -- [2]
			0.9, -- [3]
			1, -- [4]
		},
	}

	StaticPopup_Show"RELOAD_UI"
end

StaticPopupDialogs["CONFIGURE_UI"] = {
	text = "Configure freeUI?",
	button1 = YES, button2 = NO,
	OnAccept = Setup,
	timeout = 0, whileDead = 1, hideOnEscape = true,
}

StaticPopupDialogs["RELOAD_UI"] = {
	text = "Press 'Yes' to reload the UI and finish the config.",
	button1 = YES, button2 = NO,
	OnAccept = ReloadUI,
	timeout = 0, whileDead = 1, hideOnEscape = true,
}

StaticPopup_Show"CONFIGURE_UI"
DisableAddOn"!Install"